/*******************************************************************************
 * Copyright (c) 2003, 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 * Port to the D programming language:
 *      John Reimer <terminal.node@gmail.com>
 *******************************************************************************/
module dwt.browser.DownloadFactory_1_8;

import dwt.dwthelper.utils;

//import dwt.internal.C;
import XPCOM = dwt.internal.mozilla.XPCOM;
import dwt.internal.mozilla.Common;
//import dwt.internal.mozilla.XPCOMObject;
import dwt.internal.mozilla.nsID;
import dwt.internal.mozilla.nsIFactory;
import dwt.internal.mozilla.nsISupports;

class DownloadFactory_1_8 : nsIFactory {
    //XPCOMObject supports;
    //XPCOMObject factory;
    int refCount = 0;

this () {
    //createCOMInterfaces ();
}

nsrefcnt AddRef () {
    refCount++;
    return refCount;
}
/+
void createCOMInterfaces () {
    /* Create each of the interfaces that this object implements */
    supports = new XPCOMObject (new int[] {2, 0, 0}) {
        public int /*long*/ method0 (int /*long*/[] args) {return QueryInterface (args[0], args[1]);}
        public int /*long*/ method1 (int /*long*/[] args) {return AddRef ();}
        public int /*long*/ method2 (int /*long*/[] args) {return Release ();}
    };
    
    factory = new XPCOMObject (new int[] {2, 0, 0, 3, 1}) {
        public int /*long*/ method0 (int /*long*/[] args) {return QueryInterface (args[0], args[1]);}
        public int /*long*/ method1 (int /*long*/[] args) {return AddRef ();}
        public int /*long*/ method2 (int /*long*/[] args) {return Release ();}
        public int /*long*/ method3 (int /*long*/[] args) {return CreateInstance (args[0], args[1], args[2]);}
        public int /*long*/ method4 (int /*long*/[] args) {return LockFactory ((int)/*64*/args[0]);}
    };
}

void disposeCOMInterfaces () {
    if (supports !is null) {
        supports.dispose ();
        supports = null;
    }   
    if (factory !is null) {
        factory.dispose ();
        factory = null; 
    }
}

int /*long*/ getAddress () {
    return factory.getAddress ();
}
+/
nsresult QueryInterface (nsIID* riid, void** ppvObject) {
    if (riid is null || ppvObject is null) return XPCOM.NS_ERROR_NO_INTERFACE;
    //nsID guid = new nsID ();
    //XPCOM.memmove (guid, riid, nsID.sizeof);
    
    if (*riid == nsISupports.IID) {
        *ppvObject = cast(void*)cast(nsISupports)this;
        AddRef ();
        return XPCOM.NS_OK;
    }
    if (*riid == nsIFactory.IID) {
        *ppvObject = cast(void*)cast(nsIFactory)this;
        AddRef ();
        return XPCOM.NS_OK;
    }
    
    *ppvObject = null;
    return XPCOM.NS_ERROR_NO_INTERFACE;
}
            
nsrefcnt Release () {
    refCount--;
    //if (refCount is 0) disposeCOMInterfaces ();
    return refCount;
}

/* nsIFactory */

nsresult CreateInstance (nsISupports aOuter, nsIID* iid, void** result) {
    if (result is null) 
        return XPCOM.NS_ERROR_INVALID_ARG;
    auto download = new Download_1_8;
    nsresult rv = download.QueryInterface( iid, result );
    if (XPCOM.NS_FAILED(rv)) {
        *result = null;
        delete download;
    }
    return rv;
}

nsresult LockFactory (PRBool lock) {
    return XPCOM.NS_OK;
}
}
